

import java.io.File;
import java.util.ResourceBundle;

import database.DbSettings;
import database.TableUsers;

import sdljava.*;
import sdljava.audio.SDLAudio;
import sdljava.mixer.SDLMixer;
import sdljava.ttf.SDLTTF;
import sdljava.video.*;

public class Main{
	
//---------------------------------------------------------    	  	
//DECLARAR VARIABLES
//---------------------------------------------------------

	private boolean end ; //determina cuando salir del programa
	private boolean fullscreen ;

	private SDLSurface screen;

	private Text textCalculator40;

	private User user;
	
	private Options options;
	
	private 	CFrame frameBackgroundMain;
	private CSprite spriteBackgroundMain;

	private CFrame frameHand;
	private CSprite spriteHand;
	
	private CFrame [][]framemenu;
	
	private CSprite[] spritemenu;
	
	private   int maxmenu;
	private  int nummenu;
   
	private Event event;
	
	DbSettings dbsettings;
	
	int language ;
	
	public void initsystem() throws SDLException{
    	
    	SDLMain.init(SDLMain.SDL_INIT_AUDIO);
			
		 //public static void openAudio(int frequency, int format, int channels, int chunksize) 
		SDLMixer.openAudio(22000, SDLAudio.AUDIO_S16SYS,2, 1024); //aumentando chunksize disminuye el tiempo de aparicion del sonido, pero disminuye calidad
       // SDLMixer.openAudio(22050, SDLAudio.AUDIO_S16SYS, 1, 1024); //aumentando chunksize disminuye el tiempo de aparicion del sonido, pero disminuye calidad

		//System.out.println(SDLVideo.videoDriverName());
		SDLMain.init(SDLMain.SDL_INIT_EVERYTHING);
	    screen = SDLVideo.setVideoMode(800, 600, 32,SDLVideo.SDL_SWSURFACE|SDLVideo.SDL_ANYFORMAT);
    	
	    SDLTTF.init();
    }

    public void close(){
    		
    	//System.out.println("Gracias por jugar");
    	if (options.getFullscreen()){
			screen.wmToggleFullScreen();
			fullscreen=!fullscreen;
    	}
    
    }
	public void initsprites() {
		
//init sprites
		try{
			frameBackgroundMain = new CFrame();
			spriteBackgroundMain = new CSprite();
			
			frameHand = new CFrame();
			spriteHand = new CSprite();
	
			framemenu = new CFrame[maxmenu][2];
			spritemenu = new CSprite[maxmenu];
			
			for (int i = 0 ;i<maxmenu;i++){
				framemenu[i][0] = new CFrame();
				framemenu[i][1] = new CFrame();
				spritemenu[i] = new CSprite();
				
				framemenu[i][0].load("sprites"+  File.separator + "menu" + File.separator+"menu"+i+"en.png");
				framemenu[i][1].load("sprites"+  File.separator + "menu" + File.separator+"menu"+i+"es.png");
			
				spritemenu[i].addframe(framemenu[i][0]);
				spritemenu[i].addframe(framemenu[i][1]);
			}
			
			frameBackgroundMain.load("sprites"+  File.separator + "pianointro.png");
			spriteBackgroundMain.addframe(frameBackgroundMain);
	
			frameHand.load("sprites"+  File.separator + "hand.png");
			spriteHand.addframe(frameHand);
		}
		catch(Exception e){
			System.out.println("Error main.initsprites "+e);
		}
		
	}
	
	public void init() throws Exception{ //inicializa
		
		event = new Event();
		//piano.getdevices();
		
		options = new Options();
		options.initlocale("en");
		fullscreen=false;
		
		nummenu=0;
		maxmenu=6;
		
		end = false;
		
	    user = new User();
	    
	    textCalculator40 = new Text();
	    textCalculator40.init("fonts"+  File.separator + "calculator.ttf",40);
	    textCalculator40.setcolor(47, 131, 43);

	}
	
//---------------------------------------------------------    	  	
//PROCESOS PINTAR
//---------------------------------------------------------

	@SuppressWarnings("static-access")
	public void draw(SDLSurface screen) {
		
		try{
			
			spriteBackgroundMain.draw(screen);
			
			String language = options.local.getDefault().toString();

			for (int i = 0;i<maxmenu;i++){
				
				if (language.equalsIgnoreCase("en_US")){
					spritemenu[i].setframe(0);
				}
				else{
					spritemenu[i].setframe(1);
				}
				spritemenu[i].setx(155+58*i);
				spritemenu[i].sety(430);
				spritemenu[i].draw(screen);
			}
			
			//textCalculator15.drawtext( language.getString(3) + " : " , screen, 133, 80);
			if (user.getUser().getName().length() < 9 ){
				textCalculator40.drawtext(" " + user.getUser().getName() , screen, 133, 75);
	
			}
			else{
				textCalculator40.drawtext(" " + user.getUser().getName().substring(0,9) , screen, 133, 80);
	
			}
			
			spriteHand.sety(450);

			spriteHand.draw(screen);
			
			screen.flip(); //Pintamos la pantalla
		}
		catch(Exception e){
			System.out.println("Error main.draw "+e);
		} 
	  //	screen.fillRect(0); //borramos la pantalla anterior
	}

//---------------------------------------------------------    	  	
//PROCESOS INPUT
//---------------------------------------------------------
	public void keyboard(SDLSurface screen){
		
		int sym = 0;
		event.setEvent();
		
		if (event.isPressed()){
			
			sym = event.getSym();
			
			switch (sym){
			
			case 27 :  //esc
	    		
	 	    	nummenu = maxmenu-1;
	    		break;
		
	    	case 273:
	    		if (nummenu > 0 ){
	    			
	    			nummenu--;
	    		}
	    		break;
	    	case 274:
	    		if (nummenu+1 < maxmenu){
	    			nummenu++;
	    		}
	    		break;
	    	case 13:
	    		
	    		/*if (nummenu == 0){ //story mode
	    			
	    			SelectStory selectstory = new SelectStory();
	    			selectstory.go(screen);
	    		}*/
	    		if (nummenu==0){ //nueva partida
	    			
			    	SelectSong selectsong = new SelectSong();
			    	
			    	selectsong.go(screen);
			    	
	    		}
	    		if (nummenu==1){ //freemode
	    			
		    		FreeMode freemode = new FreeMode();
		    		freemode.go(screen);
			    	
	    		}
	    		if (nummenu==2){ //opciones
	    			
	    			options.go(this.screen);
	    			
	    		}
	    		if (nummenu==3){ //usuarios
	    			user.go(this.screen);
	    		}
	    		if (nummenu==4){
	    			AdminSong adminsong = new AdminSong();
	    			adminsong.go(screen);
	    			
	    		}
	    		if (nummenu==5){ //salir
	    			
		    		end = true;
	    		}
			}
		}	
	}

//---------------------------------------------------------    	  	
//PROCESO MAIN
//---------------------------------------------------------
	public static void main(String[] args) throws Exception {
   
		new Main().run();
	}
	
//---------------------------------------------------------    	  	
//PROCESO PRINCIPAL
//---------------------------------------------------------

	@SuppressWarnings("static-access")
	public void run() throws Exception{
		
//---------------------------------------------------------    	  	
//INICIALIZAR
//---------------------------------------------------------	
		initsystem();
		
		init();
		
		Popup popup = new Popup();
    	popup.set(ResourceBundle.getBundle("Language",options.local.getDefault()).getString("Conectividad"), 
    			ResourceBundle.getBundle("Language",options.local.getDefault()).getString("Conectividad_msg"),
    			ResourceBundle.getBundle("Language",options.local.getDefault()).getString("Offline"),
    			ResourceBundle.getBundle("Language",options.local.getDefault()).getString("Online"));
    	int sel = popup.go(screen);
    	
    	while (sel==1){ //online
	    	
	    		Options.setOnline(true);
	    		
	    		dbsettings = new DbSettings();
	    			
	    		if (dbsettings.isConnected()){
	    		
	    			Login login = new Login();
	            	
	            	sel = login.go(screen);
	            	
	            	if (sel == 0){
	            		sel = 1;
	            	}
	            	else{
	            		sel = 0;
	            	}
	            	
	    		}
	    		else{

	    			Popup errorconexion = new Popup();
	    			errorconexion.set(ResourceBundle.getBundle("Language", Options.local.getDefault()).getString("Conectividad"), 
	    					"No se ha podido realizar la conexión, ¿Desea cambiar a modo offline?",
	    					"Offline",
	    					"Reintentar");
	    			sel = errorconexion.go(screen); 
	    	
	    		}
    	}
    	
    	if (sel==0){ //offline
    		Options.setOnline(false);
    		user.go(screen);
    		
    		if (user.getUser() == null){
    			TableUsers anonymous = new TableUsers();
    			anonymous.setName("Anonymous");
    			anonymous.setPass("");
    			anonymous.setEmail("");
    			//anonymous.setAdded(Date.parse("0000-00-00"));
    			user.setUser(anonymous);
    		}
    	}

		initsprites();
//---------------------------------------------------------    	  	
//BUCLE PRINCIPAL
//---------------------------------------------------------		
	long inittime = 0;
	long endtime = 0;
	 int constskip = 50;
	long totaltime = 0;
	 int sleeptime = 5;
    int skip = 0;
	    
	while (!end){ //bucle principal del juego
	
	 //	sleeptime = Math.max((int)(constskip -totaltime),0);
		
		Thread.sleep( sleeptime);
		
		inittime = System.currentTimeMillis();
    
		keyboard(screen);
		
		constant();

        if (skip > totaltime ){
        	
        	this.draw(screen);
        	skip = 0;
        	
	        endtime = System.currentTimeMillis();
			totaltime =  endtime-inittime ;
			
        }
        else{
        	
        	skip = skip + 5;
        }
	} //fin while	
	    close();
	    
	    System.exit(0);
	
  } //fin Main
	private void constant(){
		if (spriteHand.getx() < 100 + nummenu*60){
			spriteHand.setx(spriteHand.getx() +5  );
	
		}
		else if (spriteHand.getx() >100 + nummenu*60){
			spriteHand.setx(spriteHand.getx() -5);
			
		}
	}
}
